import 'dart:core';

import 'package:fiscommon/json_convert.dart';
import 'package:fisjsonrpc/client_base.dart';
import 'login.m.dart';

/// 登录服务
class LoginService extends JsonRpcClientBase {
  LoginService(
    String host, {
    String serviceName = "ILoginService",
    Map<String, String>? headers,
    int? timeout,
  }) : super(
          host,
          serviceName,
          headers: headers,
          timeout: timeout,
        ) {
    /// 注册响应实体反序列化处理器
    FJsonConvert.setDecoder((map) => LoginResult.fromJson(map));
  }

  /// 登录
  Future<LoginResult> clientLoginAsync(LoginRequest request) async {
    var rpcRst = await call("ClientLoginAsync", request);
    var result = LoginResult.fromJson(rpcRst as Map<String, dynamic>);
    return result;
  }
}
